#include <sys/param.h>
#include <sys/systm.h>
#include <sys/types.h>

#include <sys/socket.h>

#include <net/if.h>
#include <net/if_arp.h>
#include <net/if_var.h>
#include <net/ethernet.h>
#include <net/if_dl.h>
#include "setmac.h"

/* XXX this should be in a header. */
extern int	setmac __P((struct proc *p, struct setmac_args *uap, int retval[]));


int
setmac( p, uap, retval)
struct proc	*p;
struct setmac_args		*uap;
int		retval[];
{
	struct ifnet		*ifp;
	struct ifaddr		*ifa;
	struct sockaddr_dl	*sdl;
	int			error;
	unsigned char		newaddr[ETHER_ADDR_LEN];

	bzero(newaddr, 6);
	error = copyin((caddr_t)uap->addr, (caddr_t)newaddr, ETHER_ADDR_LEN);
	if (error)
		return(error);

	ifp = ifunit(uap->iface);

	if (ifp == NULL) {
		printf("%s: no such device\n", uap->iface);
		return(ENODEV);
	}

	ifa = ifnet_addrs[ifp->if_index - 1];
	if (ifa == NULL)
		return(ENODEV);

	sdl = (struct sockaddr_dl *)ifa->ifa_addr;
	if (sdl == NULL)
		return(ENODEV);

	bcopy(newaddr, ((struct arpcom *)ifp->if_softc)->ac_enaddr,
		ETHER_ADDR_LEN);
	bcopy(newaddr, LLADDR(sdl), ETHER_ADDR_LEN);

	if (ifp->if_flags & IFF_UP)
		(*ifp->if_init)(ifp->if_softc);

	return( 0);	/* success (or error code from errno.h)*/
}
