#include <sys/param.h>
#include <sys/proc.h>
#include <sys/systm.h>
#include <sys/conf.h>
#include <sys/mount.h>
#include <sys/exec.h>
#include <sys/sysent.h>
#include <sys/lkm.h>
#include <a.out.h>
#include <sys/file.h>
#include <sys/errno.h>

#include "setmac.h"

/* XXX this should be in a header. */
extern int	setmac __P((struct proc *p, void *uap, int retval[]));

/* XXX these should be generated by MOD_SYSCALL(). */
static int	newsyscall_load __P((struct lkm_table *lkmtp, int cmd));
extern int	setmac_mod __P((struct lkm_table *lkmtp, int cmd, int ver));

/*
 * These two entries define our system call and module information.  We
 * have 0 arguments to our system call.
 */
static struct sysent newent = {
	2,	setmac		/* # of args, function pointer*/
};

MOD_SYSCALL("setmac_mod", SETMAC_SYSCALL, &newent);

/*
 * This function is called each time the module is loaded.   Technically,
 * we could have made this "lkm_nullcmd" in the "DISPATCH" in "newsyscall()",
 * but it's a convenient place to kick a copyright out to the console.
 */
static int
newsyscall_load( lkmtp, cmd)
struct lkm_table	*lkmtp;
int			cmd;
{
	return( 0);
}

/*
 * External entry point; should generally match name of .o file.  The
 * arguments are always the same for all loaded modules.  The "load",
 * "unload", and "stat" functions in "DISPATCH" will be called under
 * their respective circumstances unless their value is "lkm_nullcmd".  If
 * called, they are called with the same arguments (cmd is included to
 * allow the use of a single function, ver is included for version
 * matching between modules and the kernel loader for the modules).
 *
 * Since we expect to link in the kernel and add external symbols to
 * the kernel symbol name space in a future version, generally all
 * functions used in the implementation of a particular module should
 * be static unless they are expected to be seen in other modules or
 * to resolve unresolved symbols alread existing in the kernel (the
 * second case is not likely to ever occur).
 *
 * The entry point should return 0 unless it is refusing load (in which
 * case it should return an errno from errno.h).
 */
int
setmac_mod( lkmtp, cmd, ver)
struct lkm_table	*lkmtp;
int			cmd;
int			ver;
{
	DISPATCH(lkmtp, cmd, ver, newsyscall_load, lkm_nullcmd, lkm_nullcmd)
}
