#include <sys/syscall.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/ethernet.h>
#include <stdio.h>
#include <strings.h>
#include <unistd.h>

#include "setmac.h"

main(argc, argv)
	int			argc;
	char			*argv[];
{
	struct setmac_args	args;
	int			err;
	struct ether_addr	*eaddr;
	char			foo[6] = { 0x1, 0x2, 0x3, 0x4, 0x5, 0x6 };

	if (argc != 3) {
		printf("not enough args\n");
		exit(1);
	}

	eaddr = ether_aton(argv[2]);
	if (eaddr == NULL) {
		fprintf(stderr, "bad ethernet address\n");
		exit(1);
	}
	args.addr = (caddr_t)&eaddr->octet[0];

	strcpy(args.iface, argv[1]);

	if(( err = syscall(SETMAC_SYSCALL, args)))
		perror("setmac");

	exit(err);
}
